//+------------------------------------------------------------------+
//|                                                BarColorizer2.mq4 |
//|                                                          Kalenzo |
//|                                      bartlomiej.gorski@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "bartlomiej.gorski@gmail.com"
#property indicator_buffers 7
#property indicator_color1 Magenta
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 Lime
#property indicator_color5 Orange
#property indicator_color6 OrangeRed
#property indicator_color7 DarkOrchid

extern int ma1 = 50;
extern int ma2 = 120;
extern int ma3 = 200;

extern bool ColorBars120 = true;
extern bool ColorBars50 = true;

extern bool useComments = true;

extern bool use200alerts = true;
extern bool use120alerts = true;
extern bool use50alerts = true;

extern int alert200range = 1;
extern int alert120range = 1;
extern int alert50range = 1;


double Ma1[];
double Ma2[];
double Ma3[];

double ColHist1up[];
double ColHist1dn[];

double ColHist2up[];
double ColHist2dn[];

#property indicator_chart_window
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(7);
   
   SetIndexBuffer(0,ColHist1up);
   SetIndexBuffer(1,ColHist1dn);
   SetIndexBuffer(2,ColHist2up);
   SetIndexBuffer(3,ColHist2dn);
   
   SetIndexBuffer(4,Ma1);
   SetIndexBuffer(5,Ma2);
   SetIndexBuffer(6,Ma3);

   SetIndexStyle(0,DRAW_HISTOGRAM,EMPTY,1);
   SetIndexStyle(1,DRAW_HISTOGRAM,EMPTY,1);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_DOT,1);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_DOT,1);

   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID,1);
   SetIndexStyle(5,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(6,DRAW_LINE,STYLE_DASH,1);
   
   SetIndexLabel(4,"EMA 50");
   SetIndexLabel(5,"EMA 120");
   SetIndexLabel(6,"EMA 200");
   
   IndicatorShortName("BarColorizer2");
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
   int limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) counted_bars=0;
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
 
    
   for(int i = 0 ;i <= limit ;i++)
   {
      Ma1[i] = iMA(NULL,0,ma1,0,MODE_EMA,PRICE_CLOSE,i);
      Ma2[i] = iMA(NULL,0,ma2,0,MODE_EMA,PRICE_CLOSE,i);
      Ma3[i] = iMA(NULL,0,ma3,0,MODE_EMA,PRICE_CLOSE,i);
      
      if(i==0)
      {//use alerts only on bar 0
         if(use200alerts && (Bid <= Ma3[0]+(alert200range*Point)) && (Bid >= Ma3[0]-(alert200range*Point)) )        
         Alert(Symbol()+" "+Period()+" MA 200 range reached at "+Bid);
         
         if(use120alerts && (Bid <= Ma2[0]+(alert120range*Point)) && (Bid >= Ma2[0]-(alert120range*Point)) )        
         Alert(Symbol()+" "+Period()+" MA 120 range reached at "+Bid);
         
         if(use50alerts && (Bid <= Ma1[0]+(alert50range*Point)) && (Bid >= Ma1[0]-(alert50range*Point)) )        
         Alert(Symbol()+" "+Period()+" MA 50 range reached at "+Bid);
      }
      
      if(useComments && High[i] < Ma1[i] && High[i] < Ma2[i])
      Comment("Market is trending DOWN");
      else if(useComments && Low[i] > Ma1[i] && Low[i] > Ma2[i])
      Comment("Market is trending UP");
      else if(!useComments)
      Comment("");
      
      
      if(ColorBars50)
      {      
         if(High[i] < Ma1[i] && High[i] < Ma2[i])
         {
            ColHist1up[i] = High[i];
            ColHist1dn[i] = Low[i];
         }
         else if(Low[i] > Ma1[i] && Low[i] > Ma2[i])
         {
            ColHist1up[i] = Low[i];
            ColHist1dn[i] = High[i];
         }
      }
      else
      {
            ColHist1up[i] = 0;
            ColHist1dn[i] = 0;
      }
      
      if(ColorBars120)
      {
         if(High[i] <= Ma2[i])
         {
            ColHist2up[i] = High[i];
            ColHist2dn[i] = Low[i];
         }
         else if(Low[i] >= Ma2[i])
         {
            ColHist2up[i] = Low[i];
            ColHist2dn[i] = High[i];
         }
      }
      else
      {
            ColHist2up[i] = 0;
            ColHist2dn[i] = 0;
      }      
      
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+